
import java.io.* ;
import hpjava.* ;


public class Mandel {

  //static final int N             = 512   ;
  static final int N             = 256   ;
  static final int RESOLUTION    = 255   ;

  static final int BLOCKSIZEMAX  = 1024  ;

  static final int ARRAYSIZE     = N * N ;

  static final String [] hosts   = {"koum", "naos"} ;
  static final int NNODES        = hosts.length ;

  public static void main(String args[]) {

    try {
      // Create the node processes.

      Merge pool = new Merge() ;

      for(int i = 0 ; i < NNODES ; i++) {
        Port U = new Port() ;
        Port V = new Port() ;
        Port.channel(U, V) ;

        RPC.spawn("MandelWorker", hosts [i], V) ;

        // Send parameters to node

        U.sendInt(N) ;
        U.sendInt(ARRAYSIZE) ;
        U.sendInt(BLOCKSIZEMAX) ;

        U.sendInt(RESOLUTION) ;

        pool.add(U) ;
      }

      int [] array = new int [ARRAYSIZE] ;

      int nodesActive = NNODES ;
      int counter = 0 ;   // Initalise the work counter.

      while(nodesActive > 0) {

	//  Receive request for new task (and old result data) from some node.

	Port U = pool.select() ;

	//  Send a new task to the node.

	U.sendInt(counter) ;
	if(counter >= ARRAYSIZE) nodesActive-- ;  // Just terminated one node

        counter += BLOCKSIZEMAX ;

	// Copy old result data to `array'.
     
	DataInputStream fromNode = new DataInputStream(new PortInputStream(U)) ;
	int blockBase = fromNode.readInt() ;
	int blockSize = fromNode.readInt() ;

	for(int i = 0 ; i < blockSize ; i++)
	  array [blockBase + i] = fromNode.readInt() ;
      }

      //  Write values in `array' to a `.pgm' file.
     
      PrintStream out = new PrintStream(new FileOutputStream("mandel.pgm")) ;

      out.println("P2") ;
      out.println("" + N + "  " + N) ;
      out.println("" + RESOLUTION) ;

      for(int i = 0 ; i < ARRAYSIZE ; i++) {
	out.print("" + array [i] + "  ") ;
	if(i % 20 == 19) out.println("") ;
      }
    }
    catch(Exception e) {
      System.out.println("Mandel.main: " + e) ;
    }
  }
}

